#ifndef INFORMATION_H
#define INFORMATION_H


class CInformationEventHandler {
public:
	virtual bool OnClose() { return true; }
	virtual bool OnMoving(RECT *pRect) { return false; }
	virtual bool OnEnterSizeMove() { return false; }
	virtual void OnRButtonDown() {}
	virtual bool OnKeyDown(UINT KeyCode,UINT Flags) { return false; }
};

class CInformation {
	static HINSTANCE m_hinst;
	HWND m_hwnd;
	HWND m_hwndProgramInfo;
	COLORREF m_crBackColor;
	COLORREF m_crTextColor;
	HBRUSH m_hbrBack;
	HFONT m_hFont;
	int m_FontHeight;
	int m_LineMargin;
	struct {
		int Left,Top,Width,Height;
	} m_WindowPosition;
	int m_VideoWidth;
	int m_VideoHeight;
	int m_AspectX;
	int m_AspectY;
	LPTSTR m_pszDecoderName;
	bool m_fBitRate;
	float m_BitRate;
	float m_SignalLevel;
	bool m_fRecording;
	ULONGLONG m_RecordWroteSize;
	unsigned int m_RecordTime;
	ULARGE_INTEGER m_DiskFreeSpace;
	LPTSTR m_pszProgramInfo;
	CInformationEventHandler *m_pEventHandler;
	static CInformation *GetThis(HWND hwnd);
	static LRESULT CALLBACK WndProc(HWND hwnd,UINT uMsg,WPARAM wParam,
																LPARAM lParam);
	void GetItemRect(int Item,RECT *pRect);
	void UpdateItem(int Item);
public:
	static bool Initialize(HINSTANCE hinst);
	CInformation();
	~CInformation();
	void SetEventHandler(CInformationEventHandler *pHandler);
	bool Create(HWND hwndOwner,DWORD Style,DWORD ExStyle);
	void Destroy();
	void Reset();
	bool IsVisible() const;
	void SetColor(COLORREF crBackColor,COLORREF crTextColor);
	void SetPosition(int Left,int Top,int Width,int Height);
	void GetPosition(int *pLeft,int *pTop,int *pWidth,int *pHeight) const;
	void SetVideoSize(int Width,int Height);
	void SetAspectRatio(int AspectX,int AspectY);
	void SetDecoderName(LPCTSTR pszName);
	void SetBitRate(float BitRate);
	void SetSignalLevel(float Level);
	void SetRecordStatus(bool fRecording,LPCTSTR pszFileName=NULL,
							ULONGLONG WroteSize=0,unsigned int RecordTime=0);
	void SetProgramInfo(LPCTSTR pszInfo);
};


#endif
